"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const globby_1 = __importDefault(require("globby"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const graphql_tools_1 = require("graphql-tools");
const merge_graphql_schemas_1 = require("merge-graphql-schemas");
/**
 * create a graphql schema user gbob
 * @param searchDir search directory
 * @param globs graphql root files
 * @param fileGlobs other graphql files
 */
function mkSchema(searchDir, globs, option) {
    option = option || {};
    option.cwd = searchDir;
    //查询文件
    const files = globby_1.default.sync(globs, option).map(file => path_1.default.join(searchDir, file)).filter(file => fs_1.default.statSync(file).isFile());
    //合并为一个graphql文件
    const types = files.map(file => fs_1.default.readFileSync(file) + '');
    const typeDefs = merge_graphql_schemas_1.mergeTypes(types, { all: true });
    //生成schema
    return graphql_tools_1.makeExecutableSchema({ typeDefs, resolverValidationOptions: { requireResolversForResolveType: false } });
}
exports.mkSchema = mkSchema;
